<?php

require_once "xoops/class.object.php";

define("ENUM_YYBBS_ORDER_ASC",1);
define("ENUM_YYBBS_ORDER_DESC",2);

class YYBBSMessageObject extends exXoopsObject {
	var $response_;
	
	function YYBBSMessageObject($id=null)
	{
		$this->response_=array();
		
		$this->initVar('id', XOBJ_DTYPE_INT, 0, false);
		$this->initVar('bbs_id', XOBJ_DTYPE_INT, 1, false);
		$this->initVar('serial', XOBJ_DTYPE_INT, 1, false);
		$this->initVar('uid', XOBJ_DTYPE_INT, 0, false);
		$this->initVar('name', XOBJ_DTYPE_TXTBOX, null, false, 64);
		$this->initVar('email', XOBJ_DTYPE_TXTBOX, null, false, 64);
		$this->initVar('url', XOBJ_DTYPE_URL, 'http://', false, 64);
		$this->initVar('title', XOBJ_DTYPE_TXTBOX, null, false, 64);
		$this->initVar('message', XOBJ_DTYPE_TXTAREA, null, false, null);
		$this->initVar('icon', XOBJ_DTYPE_TXTBOX, null, false, 24);
		$this->initVar('col', XOBJ_DTYPE_TXTBOX, '#000000', false, 8);
		$this->initVar('passwd', XOBJ_DTYPE_TXTBOX, null, false, 34);
		$this->initVar('parent', XOBJ_DTYPE_INT, 0, false);
		$this->initVar('inputdate', XOBJ_DTYPE_INT, 0, false);
		$this->initVar('update_date', XOBJ_DTYPE_INT, 0, false);
		$this->initVar('ip', XOBJ_DTYPE_TXTBOX, null, false, 22);
		
		if ( is_array ( $id ) )
			$this->assignVars ( $id );
	}

	/**
	@brief Cookie ˤʤxoopsUser ȾͤʤƤ򥻥åȤ
	*/
	function setDefault($cookieUser)
	{
		if(is_object($cookieUser)) {
			if(!$this->getVar('id')) {
				$this->setVar('name',$cookieUser->getVar('name','e'));
				$this->setVar('email',$cookieUser->getVar('email','e'));
				$this->setVar('url',$cookieUser->getVar('url','e'));
			}
			$this->setVar('icon',$cookieUser->getVar('icon'));
			$this->setVar('col',$cookieUser->getVar('col','e'));
			$this->setVar('passwd',$cookieUser->getVar('passwd','e'));
		}
	}

	/**
	@brief 쥹ɤ߽Ф
	*/
	function load($order=ENUM_YYBBS_ORDER_DESC)
	{
		if($this->getVar('parent')==0) {
			$handler =& YYBBS::getHandler('message');
			$criteria=new Criteria('parent',$this->getVar('id'),'=');
    		$criteria->setSort('inputdate');
    		$criteria->setOrder($order==ENUM_YYBBS_ORDER_ASC ? 'ASC' : 'DESC');
			$objs =& $handler->getObjects($criteria);
			if(count($objs))
				$this->response_=$objs;
		}
	}

	function &getStructure($type='s')
	{
		$ret =& parent::getStructure($type);

		$ret['response']=array();
		foreach($this->response_ as $r) {
			$ret['response'][]=&$r->getStructure($type);
		}

		// ۥ桼򥻥å
		if(class_exists("yybbsuser")) {
    		$uHandler=&xoops_gethandler('user');
    		$user = new YYBBSUser($uHandler->get($this->getVar('uid')));
    		$ret['yybbsuser']=$user->getArray();
    		if($ret['yybbsuser']['uid']===0) {
    			$ret['yybbsuser']['name']=$ret['name'];
    			$ret['yybbsuser']['email']=$ret['email'];
    			$ret['yybbsuser']['url']=$ret['url'];
    		}
		}

		return $ret;
	}

	/**
	Υ֥Ȥȥǡ١Ȥ³ˡ֤
	*/
	function &getTableInfo()
	{
		$tinfo = new exTableInfomation('yybbs','id');
		return ($tinfo);
	}
}

?>